/*

Koch's Curve with turtle graphics.

Copyright (c) 2011 Antonio Bonifati

This file is part of Turtle.js

Turtle.js is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License

*/

TURTLE.koch = function(canvas, size) {
	with (TURTLE) {
		ini(canvas);
		bk(size * 3 / 2);
		(function level(size) {
			pd().fd(size * 3);
			pu().bk(size).lt(120);
			pd().fd(size);
			lt(120).fd(size);
			pu().lt(120).bk(size);

			if (size < 4) return;

			level(size / 3);
			fd(size).lt(60);
			level(size / 3);
			fd(size).rt(120);
			level(size / 3);
			fd(size).lt(60);
			level(size / 3);
			bk(size * 2);
		})(size);
		draw();
	}
}

/*

Original UCB logo version.

to koch :size
  pd fd :size*3
  pu bk :size lt 120
  pd fd :size
  lt 120 fd :size
  pu lt 120 bk :size

  if :size < 4 [stop]
  koch size/3
  fd :size lt 60
  koch :size/3
  fd :size rt 120
  koch :size/3
  fd :size lt 60
  koch :size/3
  bk :size*2
end

*/
